5f16281c3c4524422d25c17230ee54a2719717f8
[xfstests-dev.git] / tests / generic / 247
1 #! /bin/bash
2 # FS QA Test No. 247
3 #
4 # Test for race between direct I/O and mmap
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2010 Red Hat, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #-----------------------------------------------------------------------
22 #
23
24 seq=`basename $0`
25 seqres=$RESULT_DIR/$seq
26 echo "QA output created by $seq"
27
28 here=`pwd`
29 tmp=/tmp/$$
30 status=1        # failure is the default!
31 trap "_cleanup; exit \$status" 0 1 2 3 7 15
32
33 _cleanup()
34 {
35     cd /
36     rm -f $tmp.* $testfile
37     wait
38 }
39
40 # get standard environment, filters and checks
41 . ./common/rc
42 . ./common/filter
43
44 # real QA test starts here
45
46 # Modify as appropriate.
47 _supported_fs generic
48 _supported_os Linux
49
50 testfile=$TEST_DIR/$seq.$$
51
52 loops=500
53 iosize=1048576
54
55 # Initialise file
56 dd if=/dev/zero of=$testfile bs=$iosize count=$loops &> /dev/null
57 [ $? -ne 0 ] && exit
58 sync
59         
60 # Direct I/O overwriter
61 dd if=/dev/zero of=$testfile oflag=direct bs=$iosize count=$loops conv=notrunc &> /dev/null &
62 [ $? -ne 0 ] && exit
63
64 # Mmap writer
65 start=`expr $loops - 1`
66 for i in `seq $start -1 0`
67 do
68         offset=`expr $i \* $iosize`
69         $XFS_IO_PROG -f -c "mmap -w $offset $iosize" -c "mwrite $offset $iosize" $testfile
70         [ $? -ne 0 ] && exit
71 done
72
73 wait
74
75 echo "Silence is golden."
76
77 # success, all done
78 status=0
79 exit